/*
 *
 * Enter the selected directory in TwinExpress from DOpus.
 *
 * (c) 1994 by K.P. van Beem (2:280/464.2, patrick.van.beem@aobh.xs4all.nl)
 *
 * Based on the DOpusLhaARexx package by Geoff Seeley (but you can better
 * use GuiArc in stead of DOpus and a script, to deal with archives)
 *
 */


DOpusPort   = 'DOPUS.1'

if ~show(l,"rexxsupport.library") then
    call addlib("rexxsupport.library",0,-30,0)
if showlist('Ports', DOpusPort) = 0 then do
   say 'Directory Opus Arexx port not found. Aborting.'
   exit
end

address 'DOPUS.1'
options results

/* setup DOpus window and tell user what's happening */
Busy on
TopText "Getting directory of CD, please wait..."

/* Get the next directory */
'Status 6 -1'
GetEntry Result
FilePath = Result
if left(FilePath,1) ~= '*' then do
   TopText "You are not in a 'Twin' directory. !!"
   Busy off
   exit
end
FilePath = SubStr(FilePath,2)
'GetNextSelected -1'
Directory=Result
if SubStr(Directory,26,9) ~= "Directory" then do
   TopText "Selected item is not a directory. ??"
   Busy off
   exit
end
if right(FilePath,1) = ':' then
   FilePath = FilePath || Strip(left(Directory,25))
else
   FilePath = FilePath || '/' || Strip(left(Directory,25))

/* Check for spaces in the filename */
if words(FilePath) > 1 then
   request "Spaces in a filename are not allowed !!"
else
   address AREXX "Rexx:DOpus/ReadDir.rexx" FilePath

exit
