/*
 *
 * Go to the root directory in TwinExpress from DOpus.
 *
 * (c) 1994 by K.P. van Beem (2:280/464.2, patrick.van.beem@aobh.xs4all.nl)
 *
 * Based on the DOpusLhaARexx package by Geoff Seeley (but you can better
 * use GuiArc in stead of DOpus and a script, to deal with archives)
 *
 *    Mods  By Ray Abram
 *     - If called on a DOpus Dir, then will tell Dopus to do a Root
 *
 */

DOpusPort   = 'DOPUS.1'

if ~show(l,"rexxsupport.library") then
    call addlib("rexxsupport.library",0,-30,0)
if showlist('Ports', DOpusPort) = 0 then do
   say 'Directory Opus Arexx port not found. Aborting.'
   exit
end

address 'DOPUS.1'
options results

/* setup DOpus window and tell user what's happening */
Busy on
TopText "Getting directory of CD, please wait..."

/* Get the current directory */
'Status 6 -1'
GetEntry Result
FilePath = Result
if left(FilePath,1) ~= '*' then do
   TopText "You are not in a 'Twin' directory. ??"
   Root
   Busy off
   exit
end
FilePath = SubStr(FilePath,2)
if right(FilePath,1) = ':' then do
   TopText "You are already at the root. !!"
   Busy off
   exit
end
Root=LastPos(':',FilePath)
if Root = 0 then do
   TopText "No root found. ??"
   Busy off
   exit
end
FilePath = Left(FilePath,Root)
address AREXX "Rexx:DOpus/ReadDir.rexx" FilePath
